<template>
    <ion-page>
        <ion-header :translucent="true">
            <ion-toolbar>
                <ion-buttons slot="start">
                    <ion-menu-button color="primary"></ion-menu-button>
                </ion-buttons>
                <ion-title>Zařízení</ion-title>
            </ion-toolbar>
        </ion-header>

        <ion-content :fullscreen="true">
            <ion-progress-bar
                v-if="loading"
                type="indeterminate"
            ></ion-progress-bar>
            <ion-segment v-model="filter">
                <ion-segment-button :value="Device_Filter.My">
                    <ion-label>Moje</ion-label>
                </ion-segment-button>
                <ion-segment-button :value="Device_Filter.Unassigned">
                    <ion-label>Nepřiřazené</ion-label>
                </ion-segment-button>
                <ion-segment-button
                    :value="Device_Filter.All"
                    v-if="appUser.data.isAdmin"
                >
                    <ion-label>Všechny</ion-label>
                </ion-segment-button>
            </ion-segment>

            <ion-grid>
                <ion-row>
                    <ion-col class="center">
                        <ion-button
                            @click="createDevice"
                            color="primary"
                            shape="round"
                            ><ion-icon
                                slot="icon-only"
                                :icon="create"
                            ></ion-icon>
                            Připravit nové zařízení</ion-button
                        ></ion-col
                    >
                </ion-row>
                <ion-row>
                    <ion-col
                        size="12"
                        size-md="6"
                        size-lg="4"
                        v-for="device in deviceList"
                        :key="device.id"
                    >
                        <device-card
                            :device="device"
                            :appUser="device.owner"
                            @editClick="editDevice"
                            @removeClick="remove"
                    /></ion-col>
                </ion-row>
                <ion-row>
                    <ion-infinite-scroll
                        @ionInfinite="ionInfinite"
                        v-if="result?.deviceList?.pageInfo.hasNextPage"
                    >
                        <ion-infinite-scroll-content
                            loading-text="Prosím počkejte..."
                            loading-spinner="bubbles"
                        ></ion-infinite-scroll-content>
                    </ion-infinite-scroll>
                </ion-row>
            </ion-grid>

            <h2 class="center" v-if="deviceList.length < 1">Žádné zařízení</h2>
        </ion-content>
    </ion-page>
</template>

<script setup lang="ts">
import { DeviceEdge, Device_Filter } from '@/gql/graphql'
import {
    IonInfiniteScroll,
    IonInfiniteScrollContent,
    InfiniteScrollCustomEvent,
    IonGrid,
    IonRow,
    IonCol,
    IonSegment,
    IonSegmentButton,
    IonLabel,
    IonButton,
    IonProgressBar,
    IonContent,
    IonHeader,
    IonMenuButton,
    IonPage,
    IonTitle,
    IonToolbar,
    IonIcon,
    IonButtons,
} from '@ionic/vue'
import { useMutation, useQuery } from '@vue/apollo-composable'
import gql from 'graphql-tag'
import { computed, onUpdated, ref, watch } from 'vue'
import DeviceCard from '@/component/Device/DeviceCard.vue'
import { useUserStore } from '@/stores/userStore'
import { create } from 'ionicons/icons'
import router from '@/router'
import { Route } from '@/router/route'
import toast from '@/helpers/toast'

const appUser = useUserStore()

const filter = ref(Device_Filter.My)

const { loading, result, refetch, fetchMore } = useQuery(
    gql`
        query deviceList($filter: DEVICE_FILTER!, $after: Cursor) {
            deviceList(first: 6, after: $after, filter: $filter) {
                edges {
                    node {
                        id
                        name
                        mac
                        ip
                        isKnown
                        isKnownExpiration
                        hasInternetAccess
                        internetAccessExpiration
                        wifiName
                        wifiPass
                        isAllowed
                        createdAt
                        updatedAt
                        owner {
                            id
                            username
                            name
                            isAdmin
                            state
                            roles
                            lastLoginAt
                            createdAt
                            updatedAt
                        }
                        deviceGroupList {
                            id
                            name
                        }
                        devicePortList {
                            id
                            hubPort
                            devicePort
                            expiration
                        }
                        devicePhotoList {
                            id
                            filename
                        }
                        staticIp {
                            id
                            ip
                            expiration
                        }
                    }
                }
                pageInfo {
                    endCursor
                    hasNextPage
                }
            }
        }
    `,
    {
        filter,
    }
)

watch(filter, () => {
    refetch({
        filter: filter.value,
    })
})

const ionInfinite = (ev: InfiniteScrollCustomEvent) => {
    fetchMore({
        variables: {
            filter: filter.value,
            after: result?.value?.deviceList?.pageInfo.endCursor,
        },
    })
    //generateItems();
    setTimeout(() => ev.target.complete(), 500)
}

onUpdated(() => {
    refetch()
})

const deviceList = computed(() => {
    const edgeList = result?.value?.deviceList?.edges
    return edgeList ? edgeList.map((edge: DeviceEdge) => edge.node) : []
})

const createDevice = () => router.push({ name: Route.device })
const editDevice = (id: string) =>
    router.push({ name: Route.device, params: { id } })

// Smazat
const { mutate: removeDevice } = useMutation(gql`
    mutation removeDevice($id: ID!) {
        removeDevice(id: $id)
    }
`)

const remove = (id: string) =>
    removeDevice({ id }).then(() => {
        refetch()
        toast(id + ' smazáno', 'success')
    })
</script>
<style>
.center {
    margin-top: 1em;
    text-align: center;
}
</style>
